using System;
using System.Collections;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using Outlook = Interop.Outlook;

namespace NewEmailsExample
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("076053A4-3B10-413F-B5C5-87BD81477794"), ProgId("NewEmailsExample.AddinModule"), RunInstaller(true)]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
		private OutlookItemsEventsClass1 eventObject = null;

		public AddinModule()
        {
            InitializeComponent();
        }

		private AddinExpress.MSO.ADXOutlookAppEvents adxOutlookEvents;
		private AddinExpress.MSO.ADXOlExplorerCommandBar adxOlExplorerCommandBar1;
		private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton1;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
			this.components = new System.ComponentModel.Container();
			this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
			this.adxOlExplorerCommandBar1 = new AddinExpress.MSO.ADXOlExplorerCommandBar(this.components);
			this.adxCommandBarButton1 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			// 
			// adxOutlookEvents
			// 
			this.adxOutlookEvents.NewMailEx += new AddinExpress.MSO.ADXOlNewMailEx_EventHandler(this.adxOutlookEvents_NewMailEx);
			this.adxOutlookEvents.NewMail += new System.EventHandler(this.adxOutlookEvents_NewMail);
			// 
			// adxOlExplorerCommandBar1
			// 
			this.adxOlExplorerCommandBar1.CommandBarName = "adxOlExplorerCommandBar1";
			this.adxOlExplorerCommandBar1.CommandBarTag = "87e3c136-25a1-4d55-ad81-9021d6d18c23";
			this.adxOlExplorerCommandBar1.Controls.Add(this.adxCommandBarButton1);
			this.adxOlExplorerCommandBar1.Temporary = true;
			this.adxOlExplorerCommandBar1.UpdateCounter = 3;
			// 
			// adxCommandBarButton1
			// 
			this.adxCommandBarButton1.Caption = "Show Counter";
			this.adxCommandBarButton1.ControlTag = "cf581f14-6e44-4f8b-b727-78c66cf26abf";
			this.adxCommandBarButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.adxCommandBarButton1.Temporary = true;
			this.adxCommandBarButton1.UpdateCounter = 2;
			this.adxCommandBarButton1.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.adxCommandBarButton1_Click);
			// 
			// AddinModule
			// 
			this.AddinName = "NewEmailsExample";
			this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
			this.AddinBeginShutdown += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinBeginShutdown);
			this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);

		}
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

		private void adxOutlookEvents_NewMailEx(object sender, string entryIDCollection)
		{
			string[] ids = entryIDCollection.Split(',');
			for(int i=0; i<ids.Length; i++)
			{
				if (AddNamedProperty(ids[i], "MyNamedProperty", "My Property Value."))
				{
				}
			}
		}

		private void adxOutlookEvents_NewMail(object sender, System.EventArgs e)
		{
			// nothing
		}

		private void AddinModule_AddinStartupComplete(object sender, System.EventArgs e)
		{
			if (HostVersion.IndexOf("9.") == 0)
			{
				eventObject = new OutlookItemsEventsClass1(this);
				eventObject.ConnectTo(AddinExpress.MSO.ADXOlDefaultFolders.olFolderInbox, true);
			}
		}

		private void AddinModule_AddinBeginShutdown(object sender, System.EventArgs e)
		{
			if (eventObject != null)
			{
				eventObject.Dispose();
			}
		}

		private void adxCommandBarButton1_Click(object sender)
		{
			/*Outlook.MAPIFolder folder = 
				eventObject.FolderObj as Outlook.MAPIFolder;
			Outlook.Items items = folder.Items;
			Outlook.MailItem item = 
				items.Item(1) as Outlook.MailItem;
			MessageBox.Show(item.Subject);
			AddNamedProperty(item.EntryID, "MyNamedProperty1", "My Property Value.");
			Marshal.ReleaseComObject(item);
			Marshal.ReleaseComObject(items);*/
		}

		public bool AddNamedProperty(string entryID, string propertyName, string _value)
		{
			object obj = null;
			bool retVal = false;
			IMAPIProp mail = null;
			Outlook._NameSpace ns = null;
			Outlook._MailItem mailObj = null;

			try
			{
				ns = OutlookApp.GetNamespace("MAPI");
				obj = ns.GetItemFromID(entryID, Type.Missing);
				if (obj is Outlook.MailItem)
				{
					mailObj = obj as Outlook.MailItem;
					try
					{
						mail = mailObj.MAPIOBJECT as IMAPIProp;
						if (mail != null)
						{
							IntPtr p = IntPtr.Zero;
							IntPtr lpszStr = IntPtr.Zero;
							IntPtr propTags = IntPtr.Zero;
							IntPtr lpszValue = IntPtr.Zero;
							IntPtr lpProblems = IntPtr.Zero;
							IntPtr lpPropValue = IntPtr.Zero;
							IntPtr _mapiNameID = IntPtr.Zero;
							SPropValue propValue = new SPropValue();
							MAPINAMEID mapiNameID = new MAPINAMEID();
							try
							{
								Guid g = Guid.NewGuid();
								_mapiNameID = Marshal.AllocHGlobal(Marshal.SizeOf(typeof(MAPINAMEID)));
		
								p = Marshal.AllocHGlobal(Marshal.SizeOf(g));
								Marshal.StructureToPtr(g, p, false);
								mapiNameID.lpguid = p;
								mapiNameID.ulKind = 1;
								lpszStr = Marshal.StringToHGlobalUni(propertyName);
								mapiNameID.lpwstrName = lpszStr;
								Marshal.StructureToPtr(mapiNameID, _mapiNameID, false);

								if (mail.GetIDsFromNames(1, ref _mapiNameID, 0x00000002, out propTags) == MAPI.S_OK)
								{
									int count = Marshal.ReadInt32(propTags);
									if (count == 1)
									{
										uint tag = (uint)Marshal.ReadInt32(new IntPtr(propTags.ToInt32()+4));
										tag = (tag | MAPI.PT_STRING8);
										lpPropValue = Marshal.AllocHGlobal(Marshal.SizeOf(typeof(SPropValue)));
										propValue.ulPropTag = tag;
										propValue.dwAlignPad = 0;
										lpszValue = Marshal.StringToHGlobalAnsi(_value);
										propValue.Value = lpszValue.ToInt64();
										Marshal.StructureToPtr(propValue, lpPropValue, false);
										if (mail.SetProps(1, lpPropValue, out lpProblems) == MAPI.S_OK)
										{
											if (mail.SaveChanges(0x00000004) == MAPI.S_OK)
											{
												retVal = true;
											}
										}
									}
								}
							}
							finally
							{
								if (lpszValue != IntPtr.Zero)
									Marshal.FreeHGlobal(lpszValue);
								if (lpPropValue != IntPtr.Zero)
									Marshal.DestroyStructure(lpPropValue, typeof(SPropValue));
								if (propTags != IntPtr.Zero)
									MAPI.MAPIFreeBuffer(propTags);
								if (p != IntPtr.Zero)
									Marshal.DestroyStructure(p, typeof(Guid));
								if (lpszStr != IntPtr.Zero)
									Marshal.FreeHGlobal(lpszStr);
								if (_mapiNameID != IntPtr.Zero)
									Marshal.DestroyStructure(_mapiNameID, typeof(MAPINAMEID));
							}
						}
					}
					finally
					{
						if (mail != null)
							Marshal.ReleaseComObject(mail);
					}
				}
			}
			catch
			{
			}
			finally
			{
				if (obj != null)
					Marshal.ReleaseComObject(obj);
				if (ns != null)
					Marshal.ReleaseComObject(ns);
			}
			return retVal;
		}

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

    }
}

