using System;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace NewEmailsExample
{
	internal class MAPI
	{
		public const int S_OK = 0;

		public const uint PR_TRANSPORT_MESSAGE_HEADERS = 0x7D001E;
		public const uint PR_BODY = 0x1000001E;
		public const uint PR_BODY_HTML = 0x1013001E;
		public const uint PR_HTML = 0x10130102;

		public const uint MV_FLAG			= 0x1000;

		public const uint PT_UNSPECIFIED	= 0;
		public const uint PT_NULL			= 1;
		public const uint PT_I2				= 2;
		public const uint PT_LONG			= 3;
		public const uint PT_R4				= 4;
		public const uint PT_DOUBLE			= 5;
		public const uint PT_CURRENCY		= 6;
		public const uint PT_APPTIME		= 7;
		public const uint PT_ERROR			= 10;
		public const uint PT_BOOLEAN		= 11;
		public const uint PT_OBJECT			= 13;
		public const uint PT_I8				= 20;
		public const uint PT_STRING8		= 30;
		public const uint PT_UNICODE		= 31;
		public const uint PT_SYSTIME		= 64;
		public const uint PT_CLSID			= 72;
		public const uint PT_BINARY			= 258;
		public const uint PT_MV_TSTRING     = (MV_FLAG | PT_STRING8);

		public const uint PR_SENDER_ADDRTYPE = (PT_STRING8 | (0x0C1E << 16));
		public const uint PR_SENDER_EMAIL_ADDRESS   = (PT_STRING8 | (0x0C1F << 16));
		public const uint PR_SENDER_NAME = (PT_STRING8 | (0x0C1A << 16));
		public const uint PR_ADDRTYPE = (PT_STRING8 | (0x3002 << 16));
		public const uint PR_ADDRTYPE_W = (PT_UNICODE | (0x3002 << 16));
		public const uint PR_EMAIL_ADDRESS = (PT_STRING8 | (0x3003 << 16));
		public const uint PR_EMAIL_ADDRESS_W = (PT_UNICODE | (0x3003 << 16));
		public const uint PR_DISPLAY_NAME = (PT_STRING8 | (0x3001 << 16));
		public const uint PR_DISPLAY_NAME_W = (PT_UNICODE | (0x3001 << 16));
		public const uint PR_ENTRYID = (PT_BINARY | (0x0FFF << 16));
		public const uint PR_EMS_AB_PROXY_ADDRESSES = unchecked((uint)(PT_MV_TSTRING | (0x800F << 16)));

			
		public const uint MAPI_NEW_SESSION        = 0x00000002;
		public const uint MAPI_FORCE_DOWNLOAD     = 0x00001000;
		public const uint MAPI_LOGON_UI           = 0x00000001;
		public const uint MAPI_ALLOW_OTHERS       = 0x00000008;
		public const uint MAPI_EXPLICIT_PROFILE   = 0x00000010;
		public const uint MAPI_EXTENDED           = 0x00000020;
		public const uint MAPI_SERVICE_UI_ALWAYS  = 0x00002000;
		public const uint MAPI_NO_MAIL            = 0x00008000;
		public const uint MAPI_USE_DEFAULT        = 0x00000040;

		public const uint AB_NO_DIALOG            = 0x00000001;
		public const uint MAPI_DIALOG             = 0x00000008;

		[DllImport("MAPI32.DLL", CharSet=CharSet.Ansi, EntryPoint="MAPIFreeBuffer@4")]
		public static extern void MAPIFreeBuffer(IntPtr lpBuffer);

	}

	[StructLayout(LayoutKind.Sequential)]
	public struct SPropValue
	{
		public uint ulPropTag;
		public uint dwAlignPad;
		public long Value;
	}
		
	[StructLayout(LayoutKind.Sequential)]
	public struct ADRENTRY
	{
		public uint ulReserved1;
		public uint cValues;
		public IntPtr rgPropVals;
	}
        
	[StructLayout(LayoutKind.Sequential)]
	public struct ADRLIST
	{
		public uint cEntries;
		public ADRENTRY aEntries;
	}

	[StructLayout(LayoutKind.Sequential)]
	public struct MAPINAMEID
	{
		public IntPtr lpguid;
		public uint ulKind;
		public IntPtr lpwstrName;
	}

	[
	ComImport, ComVisible(false),
	InterfaceType(ComInterfaceType.InterfaceIsIUnknown), 
	Guid("00020303-0000-0000-C000-000000000046")
	]
	public interface IMAPIProp
	{
		int GetLastError(int hResult, uint ulFlags, out IntPtr lppMAPIError);
		int SaveChanges(uint ulFlags);
		int GetProps(IntPtr lpPropTagArray, uint ulFlags, out uint lpcValues, out IntPtr lppPropArray);
		int GetPropList(uint ulFlags, out IntPtr lppPropTagArray);
		int OpenProperty(uint ulPropTag, ref Guid lpiid, uint ulInterfaceOptions, uint ulFlags, out IntPtr lppUnk);
		int SetProps(uint cValues, IntPtr lpPropArray, out IntPtr lppProblems);
		int DeleteProps(IntPtr lpPropTagArray, out IntPtr lppProblems);
		int CopyTo(uint ciidExclude, ref Guid rgiidExclude, IntPtr lpExcludeProps, uint ulUIParam,
			IntPtr lpProgress, ref Guid lpInterface, IntPtr lpDestObj, uint ulFlags, out IntPtr lppProblems);
		int CopyProps(IntPtr lpIncludeProps, uint ulUIParam, IntPtr lpProgress, ref Guid lpInterface,
			IntPtr lpDestObj, uint ulFlags, out IntPtr lppProblems);
		int GetNamesFromIDs(out IntPtr lppPropTags, ref Guid lpPropSetGuid, uint ulFlags,
			out uint lpcPropNames, out IntPtr lpppPropNames);
		int GetIDsFromNames(uint cPropNames, ref IntPtr lppPropNames, uint ulFlags, out IntPtr lppPropTags);
	}
}
