using System;
using System.Windows.Forms;
using Outlook = Interop.Outlook;
 
namespace NewEmailsExample
{
    /// <summary>
    /// Add-in Express Outlook Items Events Class
    /// </summary>
    public class OutlookItemsEventsClass1 : AddinExpress.MSO.ADXOutlookItemsEvents
    {
		private AddinModule addinModule;

        public OutlookItemsEventsClass1(AddinExpress.MSO.ADXAddinModule module): base(module)
        {
			addinModule = (Module as AddinModule);
        }
 
		public override void ProcessItemAdd(object item)
        {
			if (item is Outlook._MailItem)
			{
				Outlook._MailItem mailItem = 
					item as Outlook._MailItem;
				if (mailItem.UnRead)
					addinModule.AddNamedProperty(mailItem.EntryID, "MyNamedProperty", "My Property Value.");
			}
        }
 
        public override void ProcessItemChange(object item)
        {
            // TODO: Add some code
        }
 
        public override void ProcessItemRemove()
        {
            // TODO: Add some code
        }

    }
}

